package str.aterm;

import aterm.*;

/**
 * Static utils for ATerm construction
 */
public class ATermUtil
{
  public static final ATermFactory _factory;

  static
  {
    _factory = new aterm.pure.PureFactory();
  }

  public static ATerm appl(String fun, ATerm ... args)
  {
    AFun afun = _factory.makeAFun(fun, args.length, false);
    return _factory.makeAppl(afun, args);
  }

  public static ATerm astring(String fun)
  {
    AFun afun = _factory.makeAFun(fun, 0, true);
    return _factory.makeAppl(afun);
  }

  public static ATerm aint(int i)
  {
    return _factory.makeInt(i);
  }

  public static ATerm areal(double d)
  {
    return _factory.makeReal(d);
  }
}
