package str.classtree.atermify;

import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import aterm.*;
import static str.classtree.atermify.ATermifyUtil.*;
import static str.aterm.ATermUtil.*;

public class FieldAttributeATermifier extends AbstractAttributeATermifier
{
  public ATerm convert(Attribute attr)
  {
    ATerm result;

    if(attr instanceof ConstantValue)
      result = buildConstantValue((ConstantValue) attr);
    else if(attr instanceof org.apache.bcel.classfile.Deprecated)
    {
      result = buildDeprecatedAttribute((org.apache.bcel.classfile.Deprecated) attr);
    }
    else if(attr instanceof Signature)
    {
      result = appl("FieldSignature", astring(((Signature) attr).getSignature()));
    }
    else
    {
      result = buildUnknownAttribute(attr);
    }

    return result;
  }

  public ATerm buildConstantValue(ConstantValue attr)
  {
    Constant c = attr.getConstantPool().getConstant(attr.getConstantValueIndex());
    return appl("ConstantValue", new ConstantATermifier(attr.getConstantPool()).convert(c));
  }
}
